<script setup lang="ts">
import { computed, nextTick, onMounted, ref } from 'vue'
import { useStockStore } from '@/stores/stock'
import type { Stock } from '@/types/Stock'
import type { VForm } from 'vuetify/components'
import { useAuthStore } from '@/stores/auth'
import type { User } from '@/types/User'

const search = ref<string>('')
const page = ref(1)
const itemsPerPage = ref<any>(8)
const stockStore = useStockStore()
const DeleteDialog = ref(false)
const Addnewdialog = ref(false)
const authStore = useAuthStore()
const loading = ref(false)
const tab = ref('')
const AlmostOutofStockCount = computed(() =>
  filteredStock.value.filter((stock) => stock.quantity > 0 && stock.quantity <= 10)
)
const OutofStockCount = computed(() => filteredStock.value.filter((stock) => stock.quantity == 0))
const refForm = ref<VForm | null>(null)
const pageCount = computed(() => {
  return Math.ceil(filteredStock.value.length / itemsPerPage.value)
})
const pageCount1 = computed(() => {
  return Math.ceil(
    filteredStock.value.filter((stock) => stock.quantity > 0 && stock.quantity <= 10).length /
    itemsPerPage.value
  )
})
const pageCount2 = computed(() => {
  return Math.ceil(
    filteredStock.value.filter((stock) => stock.quantity == 0).length / itemsPerPage.value
  )
})
const filteredStock = computed(() => {
  const currentUser = authStore.getCurrentUser()
  const currentUserRole: User | null = authStore.getCurrentUser()
  const userId = currentUser ? currentUser.branch.id : null

  return stockStore.stocks.filter((stock) => {
    const nameMatch = stock.name.toUpperCase().includes(search.value.toUpperCase())
    const branchMatch = stock.branch?.id === userId

    if (currentUserRole!.roles.some((role) => role.name === 'Owner')) return nameMatch
    else return nameMatch && branchMatch
  })
})

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Price',
    key: 'price',
    value: (item: Stock) => item.priceUnit.toFixed(2)
  },
  {
    title: 'Quantity',
    key: 'quantity',
    value: 'quantity'
  },
  {
    title: 'Value',
    key: 'value',
    value: (item: Stock) => item.value.toFixed(2)
  },
  {
    title: 'Status',
    key: 'stock',
    value: 'stock'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
async function deleteItem(item: Stock) {
  if (!item.id) return
  await stockStore.getStock(item.id)
  DeleteDialog.value = true
}
async function editItem(item: Stock) {
  if (!item.id) return
  await stockStore.getStock(item.id)
  Addnewdialog.value = true
}
function closeDialog() {
  Addnewdialog.value = false
  nextTick(() => {
    stockStore.clearForm()
  })
}
function closeDelete() {
  DeleteDialog.value = false
  nextTick(() => {
    stockStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  closeDialog()
  await stockStore.saveStock()
}
async function deleteItemConfirm() {
  await stockStore.deleteStock()
  closeDelete()
}
onMounted(() => {
  stockStore.getStocks()
})
</script>

<template>
  <v-tabs v-model="tab" align-tabs="center" color="deep-purple-accent-4">
    <div>
      <v-tab style="color: black" :to="{ name: 'stock' }">Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'check-stock' }">Check Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'order-stock' }">Order Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'graph-stock' }">Graph</v-tab>
      <v-tab style="color: black" :to="{ name: 'report-stock' }">Report</v-tab>
    </div>
  </v-tabs>

  <!-- stock status -->
  <div class="text-center">
    <h1 style="text-align: left" class="ml-5">
      <v-icon icon="mdi-package-variant-closed"></v-icon>Stock
    </h1>
    <v-btn class="ma-2" style="background-color: darkorchid">
      <v-icon end icon="mdi-cart" size="25px" class="mr-3"></v-icon>
      <div style="text-align: left">Total Product <br />{{ filteredStock.length }}</div>
    </v-btn>
    <v-btn class="ma-2" style="background-color: limegreen">
      <v-icon end icon="mdi-currency-usd" size="25px" class="mr-3"></v-icon>
      <div style="text-align: left">
        Total Stock Value<br />
        {{ filteredStock.reduce((sum, stock) => sum + stock.value, 0).toFixed(2) }}
      </div>
    </v-btn>
    <v-btn class="ma-2" style="background-color: goldenrod; margin-bottom: 10px">
      <v-icon end icon="mdi-alert-circle" size="25px" class="mr-3"></v-icon>
      <div style="text-align: left">
        Almost Out of Stock<br />
        {{ filteredStock.filter((stock) => stock.quantity <= 10 && stock.quantity > 0).length }}
      </div>
      <v-dialog v-model:page="page" activator="parent" width="auto" height="auto">
        <v-card>
          <v-card-title>ALMOST OUT OF STOCK</v-card-title>
          <v-data-table v-model:page="page" :headers="headers" :items="AlmostOutofStockCount"
            :items-per-page="itemsPerPage">
            <template v-slot:bottom>
              <div class="text-center pt-2">
                <v-pagination v-model="page" :length="pageCount1"></v-pagination>
              </div>
            </template>
            <template v-slot:[`item.stock`]="{}">
              <div class="text-left">
                <v-chip color="orange-darken-2" text="Almost Out of stock" class="text-uppercase" label
                  size="small"></v-chip>
              </div>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
              <v-icon size="small" class="me-2" @click="editItem(item)">mdi-pencil</v-icon>
              <v-icon size="small" @click="deleteItem(item)" class="mr-2">mdi-delete</v-icon>
            </template>
          </v-data-table>

          <br />
        </v-card>
      </v-dialog>
    </v-btn>
    <v-btn class="ma-2" style="background-color: crimson">
      <v-icon icon="mdi-cart-off" size="25px" class="mr-3"></v-icon>
      <div style="text-align: left">
        Out Of Stock<br />
        {{ filteredStock.filter((stock) => stock.quantity === 0).length }}
      </div>
      <v-dialog v-model:page="page" activator="parent" width="auto" height="auto">
        <v-card>
          <v-card-title>OUT OF STOCK</v-card-title>
          <v-data-table v-model:page="page" :headers="headers" :items="OutofStockCount" :items-per-page="itemsPerPage">
            <template v-slot:bottom>
              <div class="text-center pt-2">
                <v-pagination v-model="page" :length="pageCount2"></v-pagination>
              </div>
            </template>
            <template v-slot:[`item.stock`]="{}">
              <div class="text-left">
                <v-chip color="red" text="Out of stock" class="text-uppercase" label size="small"></v-chip>
              </div>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
              <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil</v-icon>
              <v-icon size="small" @click="deleteItem(item)" class="mr-2"> mdi-delete </v-icon>
            </template>
          </v-data-table>
          <br />
        </v-card>
      </v-dialog>
    </v-btn>
  </div>
  <br />
  <br />
  <!-- ปุ่มSearch กับหัวข้อ   INVENTORY ITEM -->
  <v-card-title class="d-flex align-center pe-2">
    <v-icon icon="mdi-package-variant"></v-icon> &nbsp; STOCK ITEM
    <v-spacer></v-spacer>
    <v-btn style="background-color: saddlebrown; width: 150px; height: 45px" class="mr-4">
      Add Product
      <v-dialog v-model="Addnewdialog" activator="parent" width="auto" persistent>
        <v-sheet width="400" height="250" class="mx-auto">
          <v-card-title style="text-align: center" class="mt-5">Product</v-card-title>
          <v-form fast-fail @submit.prevent ref="refForm" style="margin-left: 10px; margin-right: 10px">
            <v-text-field clearable v-model="stockStore.editedStock.name" label="Product Name" variant="outlined"
              class="mb-3" :readonly="loading" :rules="[(v) => !!v || 'Field is required']"></v-text-field>
            <v-btn style="width: 150px; height: 50px" variant="flat" @click="closeDialog" class="ms-5"
              color="red">Cancel</v-btn>
            <v-btn style="width: 150px; height: 50px" variant="flat" @click="save" class="ms-10"
              color="success">Save</v-btn>
          </v-form>
        </v-sheet>
      </v-dialog>
    </v-btn>
    <!-- ปุ่ม search -->
    <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line flat
      hide-details variant="solo-filled"></v-text-field>
  </v-card-title>
  <v-data-table v-model:page="page" :headers="headers" :items="filteredStock" :items-per-page="itemsPerPage">
    <template v-slot:bottom>
      <div class="text-center pt-2">
        <v-pagination v-model="page" :length="pageCount"></v-pagination>
      </div>
    </template>

    <!-- Stock Status -->
    <template v-slot:[`item.stock`]="{ item }">
      <div class="text-left">
        <v-chip :color="item.quantity > 0 && item.quantity <= 10
          ? 'orange-darken-2'
          : item.quantity == 0
            ? 'red'
            : 'green'
          " :text="item.quantity > 0 && item.quantity <= 10
      ? 'Almost out of stock'
      : item.quantity == 0
        ? 'Out of stock'
        : 'In stock'
      " class="text-uppercase" label size="small"></v-chip>
      </div>
    </template>
    <template v-slot:[`item.actions`]="{ item }">
      <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil</v-icon>
      <v-icon size="small" @click="deleteItem(item)" class="mr-2"> mdi-delete </v-icon>
    </template>
  </v-data-table>

  <!-- deleteDialog -->
  <v-dialog v-model="DeleteDialog" max-width="500px">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center">you want to delete this info? 🗑️</v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
          @click="closeDelete">Cancel</v-btn>
        <v-spacer></v-spacer>
        <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
          @click="deleteItemConfirm">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
.v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: 'Kanit';
}

* {
  font-family: 'Kanit';
}

.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}
</style>
